package com.affy.jarsearcher;
import java.util.HashMap;

import org.prevayler.implementation.AbstractPrevalentSystem;

/** Prevalent system for the Users Manager Demo.
 * @author Carlos Villela
 */
public class ClassManager extends AbstractPrevalentSystem {

	/** 
	 * Map to hold all user references on the system.
	 */
	static final private HashMap _instance = new HashMap();

	public ClassManager() { }

	static public HashMap getInstance() {
    	return _instance;
	}

	static public int getSize() {
		return _instance.size();
	}

	static public void put(String className, ClassStore a) {
		_instance.put(className, a);
	}

	public static ClassStore findByPrimaryKey(String className, String jarFile) {
		ClassStore c = (ClassStore)_instance.get(className);
		if (null != c && c.getJarList().contains(jarFile))
			return(c);
		return(null);
	}
}
