package com.affy.jarsearcher;

import java.io.Serializable;
import java.util.Hashtable;
import java.util.Vector;

import com.affy.jarsearcher.exceptions.InvalidClassException;
import com.affy.jarsearcher.exceptions.JarSearcherException;

/** Represents an application with Jar files.
 * @author David Medinets
 */
public class ClassStore implements Serializable {

	private String className = null;
	private Vector jarList = new Vector();

	public boolean validate() throws InvalidClassException {
		if (getClassName() == null)
			throw new InvalidClassException("null appName");
		return true;
	}
	
	/**
	 * @see Object#toString()
	 */
	public String toString() {
		return "Application@"
			+ hashCode()
			+ "(jarList="
			+ getJarList()
			+ "(className="
			+ getClassName()
			+ ");";
	}

	/**
	 * Returns the className.
	 * @return String
	 */
	public String getClassName() {
		return className;
	}

	/**
	 * Sets the className.
	 * @param className The className to set
	 */
	public void setClassName(String className) {
		this.className = className;
	}

	/**
	 * Adds a jarName to the jarList.
	 * @param jarName The jarName to add.
	 */
	public void addJarName(String jarName) {
		if (false == getJarList().contains(jarName)) {
			getJarList().add(jarName);
		}
	}

	/**
	 * Returns the jarList
	 * @return Vector
	 */
	public Vector getJarList() {
		return jarList;
	}

	/**
	 * Sets the jarList.
	 * @param jarList The jarList to set
	 */
	public void setJarList(Vector jarList) {
		this.jarList = jarList;
	}

}