package com.affy.prevayler.commands;


import java.io.Serializable;
import java.util.HashMap;

import com.affy.prevayler.exceptions.AlreadyExistsException;
import com.affy.prevayler.util.ObjectManager;
import org.prevayler.Command;
import org.prevayler.PrevalentSystem;

/** 
 */
public final class AddString implements Command {

	private String key   = null;
	private String value = null;

	public AddString() { }
	
	public AddString(String key, String value) {
		setKey(key);
		setValue(value);
	}

	/**
	 * @see Command#execute(PrevalentSystem)
	 */
	public Serializable execute(PrevalentSystem sys) throws Exception {

		if (key== null)
			throw new Exception("Null key");
		if (value == null)
			throw new Exception("Null value");

		if (null == ObjectManager.findByPrimaryKey(key)) {
			ObjectManager.put(key, value);
		} else {
			throw new AlreadyExistsException("key [" + key + "] already exists.");
		}
		
		return this;
	}

	private void out(Object obj) {
		System.out.println(obj);   //Uncomment this line to see what the test is doing.
	}

	/**
	 * Sets the user.
	 * @param user The user to set
	 */
	public void setValue(String value) {
		this.value = value;
	}
	/**
	 * Sets the key.
	 * @param key The key to set
	 */
	public void setKey(String key) {
		this.key = key;
	}

}