package com.affy.prevayler.util;

import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.File;
import java.util.Enumeration;
import java.util.Vector;

/** Recurses down the directory hierarchy, displaying the
 * java package at each level. NOTE: This class is specifically
  * hardcoded for the com.cordiem package and sub-packages.
 */
public class GetAllSubPackages {

	/** The output file. */
    static PrintWriter writer;
    
	/**
	 * Reads the command-line arguments, runs the recursive method.
	 * 
	 * @param            args The command-line arguments.
	 */
    public static void main(String[] args) {
        
		StopWatch.add("Main");
        try {
            writer = new PrintWriter(new BufferedWriter(new FileWriter("packages.txt")));
			File root = new File("src");
	    	Vector v = new Vector();
			writeDirs(root, root, v);
	        if (! v.isEmpty()) {
				boolean firstTime = true;
				Enumeration e = v.elements();
				while (e.hasMoreElements()) {
					if (true == firstTime) {
						firstTime = false;
					} else {
						writer.print(",");
					}
					writer.print(e.nextElement());
				}
	        }
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            writer.close();
	    }
		System.out.println("Generated List of Packages in " + StopWatch.elapsedTime("Main") + " ms.");
    }
    
	/**
	 * Recurses down the directory structure; writing the package names
	 * along the way.
	 * 
	 * @param            root The base directory.
	 * @param dir The current directory.
	 */
    private static void writeDirs(File root, File dir, Vector v) {
        String files[] = dir.list();
        boolean fileFound = true;

        for (int i=0; i<files.length; i++) {
            File file = new File(dir,files[i]);
            if (file.isDirectory()) {
                writeDirs(root,file, v);
            } else if (fileFound && (files[i].endsWith(".class")

                    || files[i].endsWith(".java"))) {
                fileFound = false;
                if (root.equals(dir)) {
                    //writer.println(".");   This was incorrect assumption about Javadoc
                } else {
					v.add(dir.getPath().substring(root.getPath().length()+1).replace(File.separatorChar,'.'));
                }
            }
        }
    }
}
