package com.affy.prevayler.util;

import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;

import org.prevayler.implementation.AbstractPrevalentSystem;

/** Program to test storing String objects with the Prevayler
 * system.
 * @author David Medinets
 */
public class ObjectManager extends AbstractPrevalentSystem {

	/** 
	 * Map to hold all managed data.
	 */
	static final private HashMap _instance = new HashMap();

	/** no parameter constructor
	 */
	public ObjectManager() { }

	static public HashMap getInstance() {
    	return _instance;
	}

	static public int getSize() {
		return _instance.size();
	}

	static public void put(String key, Object value) {
		_instance.put(key, value);
	}

	public static Object findByPrimaryKey(String key) {
		//System.out.println("StringManager; key: " + key);
		return( _instance.get(key) );
	}

	static public String prevalenceBase() {
		return "PrevalenceBaseObject";
	}

	public static boolean containsValue(Object value) {
		return(_instance.containsValue(value));
	}

	public static String findByValue(Object value) {
		String result = null;
		
		Set keySet = getInstance().keySet();
		Iterator i = keySet.iterator();
		while (i.hasNext()) {
			String key = (String)i.next();
			Object o = getInstance().get(key);
			if (o != null && o.equals(value)) {
				result = key;
			}
		}
		
		return result;
	}

}